

baseStatusText:
;	db 0,1,"LEVEL: XX PICKAXE: 00 GOLD: 00",255
	db 0,1,"LEVEL: 00       ",#9E,":00 ",#84,":00 ",#81,":00",#FF


menuPushFireStr:	db #44,#45,#46,#47,#48,#49,#4A,#4B,#4C,#4D,#4E,#4F
			db #50,#51,#52,#53,#54,#55,#56,#57,#58,#59,#5A,#5B,#5C
.end:
;menuPushFireStr:     db 18,4,"PUSH FIRE/SPACE TO START",255
;menuPushFireStr2:     db 22,7,"www.retrosouls.net",255
;menuPushFireStr3:     db 21,5,"From Siberia with LOVE",255
gameOverText:	db	11,11," GAME OVER ",#FF
.end:

errorMsg:
.fileNotFound:	db	10,8,"File not found!",#FF
.fileReadError:	db	10,8,"File read error!",#FF
.incorrectFile:	db	10,8,"Incorrect file!",#FF
.diskError:	db	10,11,"Disk Error!",#FF

nextPageText:	db	23,0,"=Btn-2: Next Page, TAB: ChgDisk=",#FF
		             ;--------------------------------

outro4:
	INCBIN	"include/outro4.str.mlz"


drawString:	; Input: bc = string
    ld a,(bc) : ld d,a : inc bc :ld a,(bc) : ld e,a : inc bc
    ;coords ind de
.print:		; Input: de=screen coords, bc=string
    ;check eol
    ld a,(bc)
    cp 255 
    ret z
    add 256-96-32
    push bc : push de
    call fillTile
    pop de: pop bc
    inc e : inc bc

    jr	.print


drawLevelTitle:
	ld	hl,map+OBJMAP.title
	ld	a,255
	ld	bc,OBJMAP.headerEnd-OBJMAP.title+1
	cpir
	ret	nz		; Invalid Title
	dec	hl
	ld	bc,map+OBJMAP.title
	or	a
	sbc	hl,bc		; l=Title size
	ld	a,32
	sub	l
	srl	a
	ld	e,a		; e=X
	ld	d,0		; d=Y

	ld	hl,#1800
	ld	bc,32
	xor	a
	call	FILVRM

	ld	a,(map+OBJMAP.author)
	cp	32		; Author acronym is present?
	jr	c,50F		; No, skip
	dec	e		; Adjust the title position
	dec	e
	dec	e
	dec	e
	call	50F
	ld	bc,.byText
	call	drawString.print
	ld	hl,map+OBJMAP.author
	ld	b,3
10:	ld	a,(hl)
	add	256-96-32
	push	de,hl
	call	fillTile
	pop	hl,de
	inc	hl
	inc	e
	djnz	10B
	ret

50:	ld	bc,map+OBJMAP.title
	jr	drawString.print

.byText:
	db	' by ',#FF


drawPushFire:	; Input: flagZ: set=draw, unset=clear
    	ld	de,18*32+4
	ld	hl,(GRPNAM)
	add	hl,de
	ld	bc,menuPushFireStr.end-menuPushFireStr
	ld	a,0
	jp	z,FILVRM
	ex	de,hl
	ld	hl,menuPushFireStr
	jp	LDIRVM

updateStatusBar:
;	cp	23
;	jr	c,10F
;	ld	a,22
;10:	add a,a : ld c,a : ld b,0 : ld hl,levelsText : add hl,bc
 ;	ldi:ldi
	ex	de,hl
	call	getDecimal
.print:	ld	(hl),d
	inc	hl
	ld	(hl),e
	ld	bc,statusText
	jp	drawString


getDecimal:	; Input: a=value
		; Output: hl=Chars in decimal 00-99
	cp	99
	ld	de,#8383	; I know you're cheating!   ;)
	ret	nc
	ld	d,0
10:	sub	10
	jr	c,50F
	inc	d
	jr	10B
50:	add	10+'0'
	ld	e,a
	ld	a,d
	add	'0'
	ld	d,a
	ret

levelsText:	db "00","01","02","03","04","05"
		db "06","07","08","09","10"
		db "11","12","13","14","15"
		db "16","17","18","19","20","**"
		db #83,#83	; Fire = I know you're cheating!   ;)
    
drawLevel:
	ld	a,(currentLevel)
	ld	de,statusText+9
	cp	LASTLEVEL+1
	jr	c,updateStatusBar
	ex	de,hl
	ld	de,'*'*256+'*'
	jr	updateStatusBar.print

drawGold:
	ld	a,(heroGold)
	ld	de,statusText+30
	jr	updateStatusBar

drawPickaxe:
	ld	a,(heroPickaxe)
	ld	de,statusText+25
	jr	updateStatusBar

drawLive:
	ld	a,(heroLives)
	ld	de,statusText+20
	jr	updateStatusBar

addGold:
    ld a,(heroGold) : inc a : ld (heroGold),a
	jr	drawGold

addPickaxe:
    ld a,(heroPickaxe) : inc a
	jr	subPickaxe.save

subPickaxe:
    ld a,(heroPickaxe) : dec a
.save:	ld (heroPickaxe),a
	jr	drawPickaxe


showError:
	push	bc
	call	muteMusic
	call	stopPlayer
	call	clearScreen
	call	fillFont.center
	pop	bc
	call	drawString
	call	BEEP
	call	startPlayer
50:	halt
	ld	a,(joyPressed)
	and	#10
	jr	nz,50B
	scf
	ret


