#!/bin/bash
#Make v1.3 by FRS
#requires line_lite.sh     https://brianin3d.wordpress.com/2008/05/14/scripting-with-ansi-color-codes/

EXPORTFILES="debug.aux"		# Directory for the exported files
COMPILEERRORS=0		# Sums the erros of all Compile calls


source /usr/local/bin/vt100.colors.sh

function Compile {

	FILENAME=`echo $1 |cut -f1 -d'.'`
	echo "${vt_cyan}Compiling: ${1}${vt_none}"
	sjasmplus --nologo --syntax=m -Ishared --lstlab --lst=${EXPORTFILES}/${FILENAME}.prn --sym=${EXPORTFILES}/${FILENAME}.sym --exp=${EXPORTFILES}/${FILENAME}.inc $1 2>&1 | line_lite.sh '[eE]rror[:!]' red '[Ww]arning:' yellow 'compiled:' cyan
	local RETVAL="${PIPESTATUS[0]}"
	COMPILEERRORS=$[$COMPILEERRORS+$RETVAL]

	sed -e "s/0x000//g" -e "s/$/h ; /g" ${EXPORTFILES}/${FILENAME}.sym >${EXPORTFILES}/${FILENAME}_debugger.sym

	#mv ${EXPORTFILES}/${FILENAME}.SY2 ${EXPORTFILES}/${FILENAME}.sym

	return ${RETVAL}
}

function Copyeject {
SRCPATH=$1
DSTPATH=$2
DSTDIR=`dirname $2`
VOLUME=`echo ${DSTDIR} |cut -f-3 -d/`

if [ -d ${DSTDIR} ] ;then
	cp -v ${SRCPATH} ${DSTPATH}
	hdiutil eject ${VOLUME}
fi

}

# =============================================================

# =============================================================

#cd _utils
#./genRLE-WB.sh
#cd ..

SRCNAME="main.asm"
BINNAME="YAZZIER.ROM"
#cp Original/${BINNAME} ${BINNAME}
rm $BINNAME

pushd gfx
./megaLzSC2.sh screen.sc2
./megaLzSC2.sh menu.sc2
popd

sjasmplus include/strings_compress.asm
_utils/macOS/MegaLZ include/outro4.str

Compile ${SRCNAME}

#uips c patch/PhilipsVideoGraphicsEnhancements.ips Original/${BINNAME} ${BINNAME} 

if [ $COMPILEERRORS -eq 0 ] ;then

	if [ -d /Volumes/MSX-hdtest ] ;then
		cp -v ${BINNAME} /Volumes/MSX-hdtest/GERAL
	fi
	
	if [ -d /tmp/_bla/_MSXtst ] ;then
		cp -v ${BINNAME} /tmp/_bla/_MSXtst
	fi
	
	if [ -d  /Volumes/MSX-CFboot/TEMP ] ;then
		cp -v ${BINNAME}  /Volumes/MSX-CFboot/TEMP
		hdiutil eject /Volumes/MSX-CFboot
	fi
	
	if [ -d  /Volumes/MSX2GB ] ;then
		cp -v ${BINNAME}  /Volumes/MSX2GB/WIP
		hdiutil eject /Volumes/MSX2GB
	fi
	
	if [ -d  /Volumes/MSXTST ] ;then
		cp -v ${BINNAME}  /Volumes/MSXTST
		hdiutil eject /Volumes/MSXTST
	fi
fi	
