#!/bin/bash


#Initialization
IFS=$(printf "\t")
FILELIST="$*"
stageOrder=(-1 1 2 3 6 4 13 17 5 9 8 7 15 11 12 14 18 16 10 19 20)


#----------------------------------------------------------------------------
function convMap {
	local FILENAME="$1"
	local MAPNAME="$(basename \"$1\" | cut -f1 -d.)"
	tileSetSelector ${MAPNAME}
	local TILEFNAME="YazzieTileSet${RETURN}.tsx"
	local DIRNAME="$(dirname \"$1\")"
	local DATA=$(od -t u1 -An -v "${FILENAME}" |sed -e "s/^ *//;s/  */,/g" |tr '\n' ',' |sed -e "s/,*$//")

cat <<EOF
{ "backgroundcolor":"#1b1b1b",
 "compressionlevel":-1,
 "editorsettings":
    {
     "export":
        {
         "format":"json",
         "target":"${MAPFNAME}.json"
        }
    },
 "height":24,
 "infinite":false,
 "layers":[
        {
         "data":[${DATA}],
         "height":24,
         "id":1,
         "name":"Tile Layer 1",
         "opacity":1,
         "type":"tilelayer",
         "visible":true,
         "width":32,
         "x":0,
         "y":0
        }],
 "nextlayerid":2,
 "nextobjectid":1,
 "orientation":"orthogonal",
 "renderorder":"right-down",
 "tiledversion":"1.3.3",
 "tileheight":8,
 "tilesets":[
        {
         "firstgid":0,
         "source":"${TILEFNAME}"
        }],
 "tilewidth":8,
 "type":"map",
 "version":1.2,
 "width":32
}
EOF
}
#----------------------------------------------------------------------------
function tileSetSelector {
	local mapNumber=$[$(echo ${1: -2} |sed -e "s/^0*//")]
	local stageNumber=${stageOrder[${mapNumber}]:=-1}
	case 1 in
		$(( ${stageNumber} <= 10 )))	RETURN=1;;
		$(( ${stageNumber} <= 15 )))	RETURN=2;;
		$(( ${stageNumber} <= 21 )))	RETURN=3;;
		*)					RETURN=1;;
	esac

}


#----------------------------------------------------------------------------

for FILE in ${FILELIST} ;do
	FTYPE=$(basename "${FILE##*.}" | tr /a-z/ /A-Z/)
	OUTFILE="$(basename ${FILE} | cut -f1 -d.).json"
	TILEMAP=$RETURN

	echo "Processing ${FILE}"
	convMap "${FILE}" >${OUTFILE}
done




